<template>
  <q-page class="flex-center">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :data="data"
      :columns="columns"
      separator="cell"
      :filter="filter"
      :pagination.sync="pagination"
      row-key="id"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="add()"
          v-show="session.includes('add_role')"
          >Add Role</q-btn
        >
        <div class="col" />
        <div>
          <q-toolbar class="bg-primary text-back rounded-borders">
            <q-input
              dark
              dense
              standout
              v-model="filter"
              input-class="text-right"
              class="q-ml-md"
            >
              <template v-slot:append>
                <q-icon v-if="filter === ''" name="search" />
                <q-icon
                  v-else
                  name="clear"
                  class="cursor-pointer"
                  @click="filter = ''"
                />
              </template>
            </q-input>
          </q-toolbar>
        </div>
      </template>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          >{{ props.row.No }}</q-td
        >
        <q-td
          key="name"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.name }}</q-td
        >
        <q-td
          key="level"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.level }}</q-td
        >
        <q-td
          key="status"
          :props="props"
          :style="{ width: '5%', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            :false-value="0"
            :true-value="1"
            :disable="!session.includes('change_role')"
            @input="ChangeStatus(props.row)"
          ></q-toggle>
        </q-td>
        <q-td
          key="permissions"
          :props="props"
          :style="{ width: '5%', whiteSpace: 'normal' }"
        >
          <q-btn
            size="sm"
            color="primary"
            label="View Permission"
            no-wrap
            class="q-mr-sm"
            @click="load_permission(props.row)"
            v-show="permissionRoles.includes('view_permissionrole')"
          />
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '5%', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-center no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              @click="load(props.row)"
              class="q-mr-xs"
              v-show="session.includes('change_role')"
            />
            <q-btn
              size="sm"
              round
              rounded
              color="negative"
              icon="delete"
              @click="remove(props.row)"
              class="q-mr-xs"
              v-show="session.includes('delete_role')"
            />
          </div>
        </q-td>
      </q-tr>
    </q-table>
    <!-- add -->
    <q-dialog
      full-width
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense push icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Level" prop="level">
              <q-select
                filled
                v-model="form.level"
                :options="options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions
          align="right"
          class="bg-primary text-white"
          v-show="session.includes('add_role')"
        >
          <q-btn push rounded icon="save" @click="insert()">
            Save
            <q-tooltip>Save</q-tooltip>
          </q-btn>
          <q-btn push rounded icon="cancel" v-close-popup>
            Cancel
            <q-tooltip>Cancel</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update -->
    <q-dialog
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_edit"
            ref="form_edit"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form_edit.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Level" prop="level">
              <q-select
                filled
                v-model="form_edit.level"
                :options="options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions
          align="right"
          class="bg-primary text-white"
          v-show="session.includes('change_role')"
        >
          <q-btn push rounded icon="save" @click="update()">
            Save
            <q-tooltip>Save</q-tooltip>
          </q-btn>
          <q-btn push rounded icon="cancel" v-close-popup>
            Cancel
            <q-tooltip>Cancel</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update -->
    <q-dialog
      v-model="modal_permission"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
      full-width
      full-height
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="permissions"
            :columns="columns_permission"
            separator="cell"
            row-key="id"
            style="width: 100%"
            :pagination.sync="page_permission"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="selected" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="app_name" :props="props">{{
                props.cols[1].label
              }}</q-th>
              <q-th key="view" :props="props">{{ props.cols[2].label }}</q-th>
              <q-th key="view_org" :props="props">{{
                props.cols[3].label
              }}</q-th>
              <q-th key="view_own" :props="props">{{
                props.cols[4].label
              }}</q-th>
              <q-th key="create" :props="props">{{ props.cols[5].label }}</q-th>
              <q-th key="create_org" :props="props">{{
                props.cols[6].label
              }}</q-th>
              <q-th key="update" :props="props">{{ props.cols[7].label }}</q-th>
              <q-th key="update_org" :props="props">{{
                props.cols[8].label
              }}</q-th>
              <q-th key="delete" :props="props">{{ props.cols[9].label }}</q-th>
              <q-th key="delete_org" :props="props">{{
                props.cols[10].label
              }}</q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="selected"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.selected"
                  color="green"
                  @input="rowSelect(props.row.selected, props.row, 'selected')"
                />
              </q-td>
              <q-td
                key="app_name"
                :props="props"
                :style="{ width: '500px', whiteSpace: 'normal' }"
                >{{ props.row.model_name }}</q-td
              >
              <q-td
                key="view"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.view"
                  color="green"
                  @input="rowSelect(props.row.view, props.row, 'view')"
                />
              </q-td>
              <q-td
                key="view_org"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.view_org"
                  color="green"
                  @input="rowSelect(props.row.view_org, props.row, 'view_org')"
                />
              </q-td>
              <q-td
                key="view_own"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.view_own"
                  color="green"
                  @input="rowSelect(props.row.view_own, props.row, 'view_own')"
                />
              </q-td>
              <q-td
                key="create"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.add"
                  color="green"
                  @input="rowSelect(props.row.add, props.row, 'add')"
                />
              </q-td>
              <q-td
                key="create_org"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.add_org"
                  color="green"
                  @input="rowSelect(props.row.add_org, props.row, 'add_org')"
                />
              </q-td>
              <q-td
                key="update"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.change"
                  color="green"
                  @input="rowSelect(props.row.change, props.row, 'change')"
                />
              </q-td>
              <q-td
                key="update_org"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.change_org"
                  color="green"
                  @input="
                    rowSelect(props.row.change_org, props.row, 'change_org')
                  "
                />
              </q-td>
              <q-td
                key="delete"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.delete"
                  color="green"
                  @input="rowSelect(props.row.delete, props.row, 'delete')"
                />
              </q-td>
              <q-td
                key="delete_org"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.delete_org"
                  color="green"
                  @input="
                    rowSelect(props.row.delete_org, props.row, 'delete_org')
                  "
                />
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded icon="save" @click="add_permission()">
            Save
            <q-tooltip>Save</q-tooltip>
          </q-btn>
          <q-btn push rounded icon="cancel" v-close-popup>
            Cancel
            <q-tooltip>Cancel</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Role",
  data() {
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "level",
          label: "Level",
          field: "level",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          width: "5%",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "permissions",
          label: "View",
          field: "id",
          width: "5%",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          width: "5%",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      columns_permission: [
        { name: "selected", field: "selected", require: true, align: "left" },
        {
          name: "app_name",
          label: "Permission",
          field: "app_name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "view",
          label: "View",
          field: "view",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "view_org",
          label: "View Organization",
          field: "view_org",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "view_own",
          label: "View Owner",
          field: "view_own",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "create",
          label: "Create",
          field: "add",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "create_org",
          label: "Create Organization",
          field: "add_org",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "update",
          label: "Update",
          field: "change",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "update_org",
          label: "Update Organization",
          field: "change_org",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "delete",
          label: "Delete",
          field: "delete",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "delete_org",
          label: "Delete Organization",
          field: "delete_org",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: "",
      filter_permission: "",
      separator: "horizontal",
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      page_permission: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 20
      },
      modal_edit: false,
      modal_add: false,
      form: {
        name: "",
        node: "",
        level: null
      },
      form_edit: {},
      rules: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        level: [
          { required: true, message: "Please select level", trigger: "change" }
        ]
      },
      options: [
        { value: 0, label: "0" },
        { value: 1, label: "1" },
        { value: 2, label: "2" },
        { value: 3, label: "3" },
        { value: 4, label: "4" },
        { value: 5, label: "5" },
        { value: 6, label: "6" }
      ],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      permissions: [],
      session:
        this.$q.sessionStorage.getItem("permissions")["role"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["role"]
          : [],
      permissionRoles:
        this.$q.sessionStorage.getItem("permissions")["permissionrole"] !=
        undefined
          ? this.$q.sessionStorage.getItem("permissions")["permissionrole"]
          : [],
      sessionContent:
        this.$q.sessionStorage.getItem("permissions")["contenttype"] !=
        undefined
          ? this.$q.sessionStorage.getItem("permissions")["contenttype"]
          : [],
      modal_permission: false,
      checkall: false,
      col: [
        "view",
        "view_org",
        "view_own",
        "add",
        "add_org",
        "change",
        "change_org",
        "delete",
        "delete_org"
      ],
      form_permissions: { permissions: [] },
      role_id: ""
    };
  },

  async created() {
    await this.getdata();
  },

  methods: {
    async getdata(pageNumber) {
      try {
        this.data = await this.$services.role.read({});
        this.$services.updateindex(this.data);
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    async getcontenttype(id) {
      try {
        let data = await this.$services.contenttype.read({ role: id });
        this.permissions = data["data"];
        this.checkall = data["checkall"];
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    add() {
      this.modal_add = true;
      this.form = { name: "", node: "" };
    },

    async insert() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$services.role
            .add(this.form)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$services.success("Save Role Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },
    load(row) {
      this.form_edit = row;
      this.modal_edit = true;
    },

    async update() {
      let ctx = this;
      this.$refs.form_edit.validate(valid => {
        if (valid) {
          this.$services.role
            .update(this.form_edit, this.form_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$services.success("Update Role Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Message ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.role
            .remove(row.id)
            .then(function(e) {
              ctx.getdata();
              ctx.$services.success("Delete Role " + row.name + " Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Message ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.role
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Message Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log('>>>> Cancel')
        });
    },

    load_permission(row) {
      // if (this.sessionContent.includes('view_contenttype')) {
      this.modal_permission = true;
      this.role_id = row.id;
      try {
        this.getcontenttype(row.id);
        // console.log(row)
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
      // }
    },

    rowSelect(value, row, param) {
      if (param == "selected") {
        this.col.forEach(r => {
          row[r] = value;
        });
      } else {
        if (value) {
          var number = 0;
          row[param] = value;
          for (var i in this.col) {
            if (row[this.col[i]] == false) {
              row.selected = false;
              break;
            } else {
              number += 1;
            }
          }
          if (this.col.length == number) {
            row.selected = true;
          }
        } else {
          row.selected = false;
        }
      }
      this.checkTrue();
    },

    onSelection(value) {
      this.permissions.forEach(row => {
        row.selected = value;
        this.col.forEach(r => {
          row[r] = value;
          this.form_permissions.permissions.push({ id: row[r + "_id"] });
        });
      });
    },

    checkTrue() {
      var number = 0;
      for (var i in this.permissions) {
        if (this.permissions[i].selected == false) {
          this.checkall = false;
          break;
        } else {
          number += 1;
        }
      }

      if (this.permissions.length == number) {
        this.checkall = true;
      } else {
        this.checkall = false;
      }
    },

    add_permission() {
      this.form_permissions.permissions = [];
      let ctx = this;
      this.permissions.forEach(row => {
        this.col.forEach(r => {
          if (row[r]) {
            this.form_permissions.permissions.push(row[r + "_id"]);
          }
        });
      });

      this.$services.permission
        .add(this.role_id, this.form_permissions)
        .then(function(response) {
          ctx.$services.success("Grant Permission Success");
          ctx.modal_permission = false;
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$router);
        });
    }
  }
};
</script>

<style lang="stylus"></style>
